unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, XPMan, XiButton, StdCtrls;

type
  TForm1 = class(TForm)
    Finder: TTimer;
    Hotkey: TTimer;
    XPManifest1: TXPManifest;
    Image1: TImage;
    XiButton1: TXiButton;
    XiButton2: TXiButton;
    Label1: TLabel;
    procedure XiButton2Click(Sender: TObject);
    procedure XiButton1Click(Sender: TObject);
    procedure FinderTimer(Sender: TObject);
    procedure HotkeyTimer(Sender: TObject);
  private
    { Private declarations }
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  GameWindow : HWnd;
  PID, TID, Write : Dword;
  PHandle : THandle;

implementation

{$R *.dfm}
////////////////Arrasta de qualquer parte do Form//////////////////////////////
procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);

begin
inherited;                                         { ativa a herana da mensagem }
if M.Result = htClient then                { o clique foi na ?rea cliente? }
M.Result := htCaption;           { se sim, faz o Windows pensar que foi no Caption. }

end;
/////////////////////////////////////////////////////////////////////////////

///////////////PC Speaker///////////////////////////////////////////////////
procedure SetPort(address, Value: Word) ;
var
   bValue: Byte;
begin
   bValue := trunc(Value and 255) ;
   asm
     mov dx, address
     mov al, bValue
     out dx, al
   end;
end;

function GetPort(address: Word): Word;
var
   bValue: Byte;
begin
   asm
     mov dx, address
     in al, dx
     mov bValue, al
   end;
   GetPort := bValue;
end;

procedure Sound(aFreq, aDelay: Integer) ;

   procedure DoSound(Freq: Word) ;
   var
     B: Byte;
   begin
     if Freq > 18 then
     begin
       Freq := Word(1193181 div Longint(Freq)) ;
       B := Byte(GetPort($61)) ;

       if (B and 3) = 0 then
       begin
         SetPort($61, Word(B or 3)) ;
         SetPort($43, $B6) ;
       end;

       SetPort($42, Freq) ;
       SetPort($42, Freq shr 8) ;
     end;
   end;

   procedure Delay(MSecs: Integer) ;
   var
     FirstTickCount: LongInt;
   begin
     FirstTickCount := GetTickCount;
     repeat
       Sleep(1) ;
       //or use Application.ProcessMessages instead of Sleep
     until ((GetTickCount - FirstTickCount) >= Longint(MSecs)) ;
   end;

begin
   if Win32Platform = VER_PLATFORM_WIN32_NT then
   begin
     Windows.Beep(aFreq, aDelay) ;
   end
   else
   begin
     DoSound(aFreq) ;
     Delay(aDelay) ;
   end;
end;

procedure NoSound;
var
   Value: Word;
begin
   if not (Win32Platform = VER_PLATFORM_WIN32_NT) then
   begin
     Value := GetPort($61) and $FC;
     SetPort($61, Value) ;
   end;
end;

///////////////////////////PC Speaker////////////////////////////////////////////////////

////////////////////////////Ativando////////////////////////////////////////////////////
Procedure SandTanks;
var
Sand1 : Array[1..6] of byte;
Sand2 : Array[1..21] of byte;
SandNOP : Array[1..6] of byte;

begin
Sand1[01] := $e9;
Sand1[02] := $08;
Sand1[03] := $98;
Sand1[04] := $2a;
Sand1[05] := $00;
Sand1[06] := $90;

Sand2[01] := $8b;
Sand2[02] := $85;
Sand2[03] := $94;
Sand2[04] := $0a;
Sand2[05] := $00;
Sand2[06] := $00;
Sand2[07] := $c7;
Sand2[08] := $85;
Sand2[09] := $94;
Sand2[10] := $0a;
Sand2[11] := $00;
Sand2[12] := $00;
Sand2[13] := $06;
Sand2[14] := $00;
Sand2[15] := $00;
Sand2[16] := $00;
Sand2[17] := $e9;
Sand2[18] := $e3;
Sand2[19] := $67;
Sand2[20] := $d5;
Sand2[21] := $ff;

SandNOP[01] := $90;
SandNOP[02] := $90;
SandNOP[03] := $90;
SandNOP[04] := $90;
SandNOP[05] := $90;
SandNOP[06] := $90;

TID := GetWindowThreadProcessId(GameWindow, @PID);
PHandle := OpenProcess(PROCESS_ALL_ACCESS,FALSE,PID);
WriteProcessMemory(PHandle,Pointer($00610913),@Sand1,$06,Write);
WriteProcessMemory(PHandle,Pointer($008BA120),@Sand2,$21,Write);
WriteProcessMemory(PHandle,Pointer($00610E3A),@SandNOP,$06,Write);
Sound(5800, 100);
NoSound;
end;

Procedure Recall;
var
Recall1 : Array[1..6] of byte;
Recall2 : Array[1..18] of byte;

begin
Recall1[01] := $e9;
Recall1[02] := $5c;
Recall1[03] := $35;
Recall1[04] := $43;
Recall1[05] := $00;
Recall1[06] := $90;

Recall2[01] := $df;
Recall2[02] := $68;
Recall2[03] := $38;
Recall2[04] := $c7;
Recall2[05] := $40;
Recall2[06] := $38;
Recall2[07] := $c0;
Recall2[08] := $cf;
Recall2[09] := $6a;
Recall2[10] := $00;
Recall2[11] := $d9;
Recall2[12] := $1c;
Recall2[13] := $24;
Recall2[14] := $e9;
Recall2[15] := $92;
Recall2[16] := $ca;
Recall2[17] := $bc;
Recall2[18] := $ff;

TID := GetWindowThreadProcessId(GameWindow, @PID);
PHandle := OpenProcess(PROCESS_ALL_ACCESS,FALSE,PID);
WriteProcessMemory(PHandle,Pointer($00486BE6),@Recall1,$06,Write);
WriteProcessMemory(PHandle,Pointer($008BA147),@Recall2,$18,Write);
Sound(5800, 100);
NoSound;
end;

Procedure SlowMotion;
var
SlowMotion : Array[1..6] of byte;

begin
SlowMotion[01] := $90;
SlowMotion[02] := $90;
SlowMotion[03] := $90;
SlowMotion[04] := $90;
SlowMotion[05] := $90;
SlowMotion[06] := $90;

TID := GetWindowThreadProcessId(GameWindow, @PID);
PHandle := OpenProcess(PROCESS_ALL_ACCESS,FALSE,PID);
WriteProcessMemory(PHandle,Pointer($0062E42A),@SlowMotion,$06,Write);
Sound(5800, 100);
NoSound;
end;

Procedure Ravages;
var
Ravages : Array[1..6] of byte;

begin
Ravages[01] := $90;
Ravages[02] := $90;
Ravages[03] := $90;
Ravages[04] := $90;
Ravages[05] := $90;
Ravages[06] := $90;

TID := GetWindowThreadProcessId(GameWindow, @PID);
PHandle := OpenProcess(PROCESS_ALL_ACCESS,FALSE,PID);
WriteProcessMemory(PHandle,Pointer($006256D0),@Ravages,$06,Write);
Sound(5800, 100);
NoSound;
end;

Procedure Sword;
var
Sword1 : Array[1..5] of byte;
Sword2 : Array[1..14] of byte;

begin
Sword1[01] := $e9;
Sword1[02] := $75;
Sword1[03] := $d9;
Sword1[04] := $3a;
Sword1[05] := $00;

Sword2[01] := $c7;
Sword2[02] := $45;
Sword2[03] := $18;
Sword2[04] := $c8;
Sword2[05] := $00;
Sword2[06] := $00;
Sword2[07] := $00;
Sword2[08] := $89;
Sword2[09] := $01;
Sword2[10] := $e9;
Sword2[11] := $7d;
Sword2[12] := $26;
Sword2[13] := $c5;
Sword2[14] := $ff;

TID := GetWindowThreadProcessId(GameWindow, @PID);
PHandle := OpenProcess(PROCESS_ALL_ACCESS,FALSE,PID);
WriteProcessMemory(PHandle,Pointer($0050C7F3),@Sword1,$05,Write);
WriteProcessMemory(PHandle,Pointer($008BA16D),@Sword2,$14,Write);
Sound(5800, 100);
NoSound;
end;

Procedure Health;
var
Health1 : Array[1..6] of byte;
Health2 : Array[1..21] of byte;
Health3 : Array[1..6] of byte;
Health4 : Array[1..21] of byte;
Health5 : Array[1..10] of byte;
Health6 : Array[1..6] of byte;
Health7 : Array[1..6] of byte;

begin
Health1[01] := $e9;
Health1[02] := $90;
Health1[03] := $72;
Health1[04] := $2f;
Health1[05] := $00;
Health1[06] := $90;

Health2[01] := $8b;
Health2[02] := $85;
Health2[03] := $f4;
Health2[04] := $01;
Health2[05] := $00;
Health2[06] := $00;
Health2[07] := $c7;
Health2[08] := $85;
Health2[09] := $f4;
Health2[10] := $01;
Health2[11] := $00;
Health2[12] := $00;
Health2[13] := $78;
Health2[14] := $01;
Health2[15] := $00;
Health2[16] := $00;
Health2[17] := $e9;
Health2[18] := $5b;
Health2[19] := $8d;
Health2[20] := $d0;
Health2[21] := $ff;

Health3[01] := $e9;
Health3[02] := $3d;
Health3[03] := $68;
Health3[04] := $23;
Health3[05] := $00;
Health3[06] := $90;

Health4[01] := $8b;
Health4[02] := $85;
Health4[03] := $90;
Health4[04] := $14;
Health4[05] := $00;
Health4[06] := $00;
Health4[07] := $c7;
Health4[08] := $85;
Health4[09] := $90;
Health4[10] := $14;
Health4[11] := $00;
Health4[12] := $00;
Health4[13] := $78;
Health4[14] := $01;
Health4[15] := $00;
Health4[16] := $00;
Health4[17] := $e9;
Health4[18] := $ae;
Health4[19] := $97;
Health4[20] := $dc;
Health4[21] := $ff;

Health5[01] := $90;
Health5[02] := $90;
Health5[03] := $90;
Health5[04] := $90;
Health5[05] := $90;
Health5[06] := $90;
Health5[07] := $90;
Health5[08] := $90;
Health5[09] := $90;
Health5[10] := $90;

Health6[01] := $90;
Health6[02] := $90;
Health6[03] := $90;
Health6[04] := $90;
Health6[05] := $90;
Health6[06] := $90;

Health7[01] := $90;
Health7[02] := $90;
Health7[03] := $90;
Health7[04] := $90;
Health7[05] := $90;
Health7[06] := $90;

TID := GetWindowThreadProcessId(GameWindow, @PID);
PHandle := OpenProcess(PROCESS_ALL_ACCESS,FALSE,PID);
WriteProcessMemory(PHandle,Pointer($005C2EF3),@Health1,$06,Write);
WriteProcessMemory(PHandle,Pointer($008BA188),@Health2,$21,Write);
WriteProcessMemory(PHandle,Pointer($00683963),@Health3,$06,Write);
WriteProcessMemory(PHandle,Pointer($008BA1A5),@Health4,$21,Write);
WriteProcessMemory(PHandle,Pointer($00684324),@Health5,$10,Write);
WriteProcessMemory(PHandle,Pointer($006841BE),@Health6,$06,Write);
WriteProcessMemory(PHandle,Pointer($00684142),@Health7,$06,Write);
Sound(5800, 100);
NoSound;
end;
/////////////////////////////////////Ativado/////////////////////////////////////////

///////////////////////////////////Desativando///////////////////////////////////////////
Procedure Desativar;
var
Sand1 : Array[1..6] of byte;
Sand2 : Array[1..6] of byte;
Recall : Array[1..6] of byte;
SlowMotion : Array[1..6] of byte;
Ravages : Array[1..6] of byte;
Sword : Array[1..5] of byte;
Health1 : Array[1..6] of byte;
Health2 : Array[1..6] of byte;
HealthNOP1 : Array[1..10] of byte;
HealthNOP2 : Array[1..6] of byte;
HealthNOP3 : Array[1..6] of byte;

begin
Sand1[01] := $8b;
Sand1[02] := $85;
Sand1[03] := $94;
Sand1[04] := $0a;
Sand1[05] := $00;
Sand1[06] := $00;

Sand2[01] := $89;
Sand2[02] := $8f;
Sand2[03] := $94;
Sand2[04] := $0a;
Sand2[05] := $00;
Sand2[06] := $00;

Recall[01] := $df;
Recall[02] := $68;
Recall[03] := $38;
Recall[04] := $d9;
Recall[05] := $1c;
Recall[06] := $24;

SlowMotion[01] := $d9;
SlowMotion[02] := $9f;
SlowMotion[03] := $0c;
SlowMotion[04] := $0c;
SlowMotion[05] := $00;
SlowMotion[06] := $00;

Ravages[01] := $d9;
Ravages[02] := $9f;
Ravages[03] := $6c;
Ravages[04] := $13;
Ravages[05] := $00;
Ravages[06] := $00;

Sword[01] := $8b;
Sword[02] := $45;
Sword[03] := $18;
Sword[04] := $89;
Sword[05] := $01;

Health1[01] := $8b;
Health1[02] := $85;
Health1[03] := $f4;
Health1[04] := $01;
Health1[05] := $00;
Health1[06] := $00;

Health2[01] := $8b;
Health2[02] := $85;
Health2[03] := $90;
Health2[04] := $14;
Health2[05] := $00;
Health2[06] := $00;

HealthNOP1[01] := $c7;
HealthNOP1[02] := $87;
HealthNOP1[03] := $f4;
HealthNOP1[04] := $01;
HealthNOP1[05] := $00;
HealthNOP1[06] := $00;
HealthNOP1[07] := $00;
HealthNOP1[08] := $00;
HealthNOP1[09] := $00;
HealthNOP1[10] := $00;

HealthNOP2[01] := $89;
HealthNOP2[02] := $96;
HealthNOP2[03] := $f4;
HealthNOP2[04] := $01;
HealthNOP2[05] := $00;
HealthNOP2[06] := $00;

HealthNOP3[01] := $89;
HealthNOP3[02] := $86;
HealthNOP3[03] := $f4;
HealthNOP3[04] := $01;
HealthNOP3[05] := $00;
HealthNOP3[06] := $00;


TID := GetWindowThreadProcessId(GameWindow, @PID);
PHandle := OpenProcess(PROCESS_ALL_ACCESS,FALSE,PID);
WriteProcessMemory(PHandle,Pointer($00610913),@Sand1,$06,Write);
WriteProcessMemory(PHandle,Pointer($00610E3A),@Sand2,$06,Write);
WriteProcessMemory(PHandle,Pointer($00486BE6),@Recall,$06,Write);
WriteProcessMemory(PHandle,Pointer($0062E42A),@SlowMotion,$06,Write);
WriteProcessMemory(PHandle,Pointer($006256D0),@Ravages,$06,Write);
WriteProcessMemory(PHandle,Pointer($0050C7F3),@Sword,$05,Write);
WriteProcessMemory(PHandle,Pointer($005C2EF3),@Health1,$06,Write);
WriteProcessMemory(PHandle,Pointer($00683963),@Health2,$06,Write);
WriteProcessMemory(PHandle,Pointer($00684324),@HealthNOP1,$10,Write);
WriteProcessMemory(PHandle,Pointer($006841BE),@HealthNOP2,$06,Write);
WriteProcessMemory(PHandle,Pointer($00684142),@HealthNOP3,$06,Write);
Sound(100, 100);
NoSound;
end;
////////////////////////////////////Desativado/////////////////////////////////////////
procedure TForm1.XiButton2Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.XiButton1Click(Sender: TObject);
begin
 MessageBox (0, 'Hotkeys:     1 - Infinite Sand Tanks'+#13+#13+'                   2 - Infinite Recall Time'+#13+#13+'                   3 - Infinite Slow Motion'+#13+#13+'                   4 - Infinite Ravages Time'+#13+#13+'                   5 - Infinite Health'+#13+#13+'                   6 - Undestroyable Sword'+#13+#13+'                   0 - Back to normal'+#13+#13+'                   END - Exit!'+#13+#13+'=======================RENAN=======================' , 'Renan', 0 + MB_ICONASTERISK + MB_SETFOREGROUND + MB_TASKMODAL);
end;

procedure TForm1.FinderTimer(Sender: TObject);
begin
GameWindow := FindWindow(nil, 'Prince of Persia');
If GameWindow <> 0 then Form1.Caption := 'GameDetected!'
else
Form1.Caption := 'Run the Game!';
end;

procedure TForm1.HotkeyTimer(Sender: TObject);
begin
if (GetASyncKeyState ($24) <> 0) then PostMessage(GameWindow, WM_QUIT,0,0);
if (GetASyncKeyState ($23) <> 0) then Close;
if (GetASyncKeyState ($31) <> 0) then SandTanks;
if (GetASyncKeyState ($32) <> 0) then Recall;
if (GetASyncKeyState ($33) <> 0) then SlowMotion;
if (GetASyncKeyState ($34) <> 0) then Ravages;
if (GetASyncKeyState ($35) <> 0) then Health;
if (GetASyncKeyState ($36) <> 0) then Sword;
if (GetASyncKeyState ($30) <> 0) then Desativar;
end;

end.
